/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 115 "parser.y"


#include <stdio.h>

#include "cpu.h"
#include "error.h"
#include "lexxer.h"
#include "global.h"
#include "mig_string.h"
#include "type.h"
#include "routine.h"
#include "statement.h"

static const char *import_name(statement_kind_t sk);

void
yyerror(const char *s)
{
    error("%s", s);
}

#line 93 "parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_PARSER_H_INCLUDED
# define YY_YY_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    sySkip = 258,                  /* sySkip  */
    syRoutine = 259,               /* syRoutine  */
    sySimpleRoutine = 260,         /* sySimpleRoutine  */
    sySubsystem = 261,             /* sySubsystem  */
    syKernelUser = 262,            /* syKernelUser  */
    syKernelServer = 263,          /* syKernelServer  */
    syMsgOption = 264,             /* syMsgOption  */
    syMsgSeqno = 265,              /* syMsgSeqno  */
    syWaitTime = 266,              /* syWaitTime  */
    syNoWaitTime = 267,            /* syNoWaitTime  */
    syErrorProc = 268,             /* syErrorProc  */
    syServerPrefix = 269,          /* syServerPrefix  */
    syUserPrefix = 270,            /* syUserPrefix  */
    syServerDemux = 271,           /* syServerDemux  */
    syRCSId = 272,                 /* syRCSId  */
    syImport = 273,                /* syImport  */
    syUImport = 274,               /* syUImport  */
    sySImport = 275,               /* sySImport  */
    syIn = 276,                    /* syIn  */
    syOut = 277,                   /* syOut  */
    syInOut = 278,                 /* syInOut  */
    syRequestPort = 279,           /* syRequestPort  */
    syReplyPort = 280,             /* syReplyPort  */
    sySReplyPort = 281,            /* sySReplyPort  */
    syUReplyPort = 282,            /* syUReplyPort  */
    syType = 283,                  /* syType  */
    syArray = 284,                 /* syArray  */
    syStruct = 285,                /* syStruct  */
    syOf = 286,                    /* syOf  */
    syInTran = 287,                /* syInTran  */
    syOutTran = 288,               /* syOutTran  */
    syDestructor = 289,            /* syDestructor  */
    syCType = 290,                 /* syCType  */
    syCUserType = 291,             /* syCUserType  */
    syCServerType = 292,           /* syCServerType  */
    syCString = 293,               /* syCString  */
    syColon = 294,                 /* syColon  */
    sySemi = 295,                  /* sySemi  */
    syComma = 296,                 /* syComma  */
    syPlus = 297,                  /* syPlus  */
    syMinus = 298,                 /* syMinus  */
    syStar = 299,                  /* syStar  */
    syDiv = 300,                   /* syDiv  */
    syLParen = 301,                /* syLParen  */
    syRParen = 302,                /* syRParen  */
    syEqual = 303,                 /* syEqual  */
    syCaret = 304,                 /* syCaret  */
    syTilde = 305,                 /* syTilde  */
    syLAngle = 306,                /* syLAngle  */
    syRAngle = 307,                /* syRAngle  */
    syLBrack = 308,                /* syLBrack  */
    syRBrack = 309,                /* syRBrack  */
    syBar = 310,                   /* syBar  */
    syError = 311,                 /* syError  */
    syNumber = 312,                /* syNumber  */
    sySymbolicType = 313,          /* sySymbolicType  */
    syIdentifier = 314,            /* syIdentifier  */
    syString = 315,                /* syString  */
    syQString = 316,               /* syQString  */
    syFileName = 317,              /* syFileName  */
    syIPCFlag = 318,               /* syIPCFlag  */
    syInTranPayload = 319          /* syInTranPayload  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define sySkip 258
#define syRoutine 259
#define sySimpleRoutine 260
#define sySubsystem 261
#define syKernelUser 262
#define syKernelServer 263
#define syMsgOption 264
#define syMsgSeqno 265
#define syWaitTime 266
#define syNoWaitTime 267
#define syErrorProc 268
#define syServerPrefix 269
#define syUserPrefix 270
#define syServerDemux 271
#define syRCSId 272
#define syImport 273
#define syUImport 274
#define sySImport 275
#define syIn 276
#define syOut 277
#define syInOut 278
#define syRequestPort 279
#define syReplyPort 280
#define sySReplyPort 281
#define syUReplyPort 282
#define syType 283
#define syArray 284
#define syStruct 285
#define syOf 286
#define syInTran 287
#define syOutTran 288
#define syDestructor 289
#define syCType 290
#define syCUserType 291
#define syCServerType 292
#define syCString 293
#define syColon 294
#define sySemi 295
#define syComma 296
#define syPlus 297
#define syMinus 298
#define syStar 299
#define syDiv 300
#define syLParen 301
#define syRParen 302
#define syEqual 303
#define syCaret 304
#define syTilde 305
#define syLAngle 306
#define syRAngle 307
#define syLBrack 308
#define syRBrack 309
#define syBar 310
#define syError 311
#define syNumber 312
#define sySymbolicType 313
#define syIdentifier 314
#define syString 315
#define syQString 316
#define syFileName 317
#define syIPCFlag 318
#define syInTranPayload 319

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 138 "parser.y"

    u_int number;
    identifier_t identifier;
    const_string_t string;
    statement_kind_t statement_kind;
    ipc_type_t *type;
    struct
    {
	u_int innumber;		/* msgt_name value, when sending */
	const_string_t instr;
	u_int outnumber;	/* msgt_name value, when receiving */
	const_string_t outstr;
	u_int size;		/* 0 means there is no default size */
    } symtype;
    routine_t *routine;
    arg_kind_t direction;
    argument_t *argument;
    ipc_flags_t flag;

#line 294 "parser.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_PARSER_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_sySkip = 3,                     /* sySkip  */
  YYSYMBOL_syRoutine = 4,                  /* syRoutine  */
  YYSYMBOL_sySimpleRoutine = 5,            /* sySimpleRoutine  */
  YYSYMBOL_sySubsystem = 6,                /* sySubsystem  */
  YYSYMBOL_syKernelUser = 7,               /* syKernelUser  */
  YYSYMBOL_syKernelServer = 8,             /* syKernelServer  */
  YYSYMBOL_syMsgOption = 9,                /* syMsgOption  */
  YYSYMBOL_syMsgSeqno = 10,                /* syMsgSeqno  */
  YYSYMBOL_syWaitTime = 11,                /* syWaitTime  */
  YYSYMBOL_syNoWaitTime = 12,              /* syNoWaitTime  */
  YYSYMBOL_syErrorProc = 13,               /* syErrorProc  */
  YYSYMBOL_syServerPrefix = 14,            /* syServerPrefix  */
  YYSYMBOL_syUserPrefix = 15,              /* syUserPrefix  */
  YYSYMBOL_syServerDemux = 16,             /* syServerDemux  */
  YYSYMBOL_syRCSId = 17,                   /* syRCSId  */
  YYSYMBOL_syImport = 18,                  /* syImport  */
  YYSYMBOL_syUImport = 19,                 /* syUImport  */
  YYSYMBOL_sySImport = 20,                 /* sySImport  */
  YYSYMBOL_syIn = 21,                      /* syIn  */
  YYSYMBOL_syOut = 22,                     /* syOut  */
  YYSYMBOL_syInOut = 23,                   /* syInOut  */
  YYSYMBOL_syRequestPort = 24,             /* syRequestPort  */
  YYSYMBOL_syReplyPort = 25,               /* syReplyPort  */
  YYSYMBOL_sySReplyPort = 26,              /* sySReplyPort  */
  YYSYMBOL_syUReplyPort = 27,              /* syUReplyPort  */
  YYSYMBOL_syType = 28,                    /* syType  */
  YYSYMBOL_syArray = 29,                   /* syArray  */
  YYSYMBOL_syStruct = 30,                  /* syStruct  */
  YYSYMBOL_syOf = 31,                      /* syOf  */
  YYSYMBOL_syInTran = 32,                  /* syInTran  */
  YYSYMBOL_syOutTran = 33,                 /* syOutTran  */
  YYSYMBOL_syDestructor = 34,              /* syDestructor  */
  YYSYMBOL_syCType = 35,                   /* syCType  */
  YYSYMBOL_syCUserType = 36,               /* syCUserType  */
  YYSYMBOL_syCServerType = 37,             /* syCServerType  */
  YYSYMBOL_syCString = 38,                 /* syCString  */
  YYSYMBOL_syColon = 39,                   /* syColon  */
  YYSYMBOL_sySemi = 40,                    /* sySemi  */
  YYSYMBOL_syComma = 41,                   /* syComma  */
  YYSYMBOL_syPlus = 42,                    /* syPlus  */
  YYSYMBOL_syMinus = 43,                   /* syMinus  */
  YYSYMBOL_syStar = 44,                    /* syStar  */
  YYSYMBOL_syDiv = 45,                     /* syDiv  */
  YYSYMBOL_syLParen = 46,                  /* syLParen  */
  YYSYMBOL_syRParen = 47,                  /* syRParen  */
  YYSYMBOL_syEqual = 48,                   /* syEqual  */
  YYSYMBOL_syCaret = 49,                   /* syCaret  */
  YYSYMBOL_syTilde = 50,                   /* syTilde  */
  YYSYMBOL_syLAngle = 51,                  /* syLAngle  */
  YYSYMBOL_syRAngle = 52,                  /* syRAngle  */
  YYSYMBOL_syLBrack = 53,                  /* syLBrack  */
  YYSYMBOL_syRBrack = 54,                  /* syRBrack  */
  YYSYMBOL_syBar = 55,                     /* syBar  */
  YYSYMBOL_syError = 56,                   /* syError  */
  YYSYMBOL_syNumber = 57,                  /* syNumber  */
  YYSYMBOL_sySymbolicType = 58,            /* sySymbolicType  */
  YYSYMBOL_syIdentifier = 59,              /* syIdentifier  */
  YYSYMBOL_syString = 60,                  /* syString  */
  YYSYMBOL_syQString = 61,                 /* syQString  */
  YYSYMBOL_syFileName = 62,                /* syFileName  */
  YYSYMBOL_syIPCFlag = 63,                 /* syIPCFlag  */
  YYSYMBOL_syInTranPayload = 64,           /* syInTranPayload  */
  YYSYMBOL_YYACCEPT = 65,                  /* $accept  */
  YYSYMBOL_Statements = 66,                /* Statements  */
  YYSYMBOL_Statement = 67,                 /* Statement  */
  YYSYMBOL_Subsystem = 68,                 /* Subsystem  */
  YYSYMBOL_SubsystemStart = 69,            /* SubsystemStart  */
  YYSYMBOL_SubsystemMods = 70,             /* SubsystemMods  */
  YYSYMBOL_SubsystemMod = 71,              /* SubsystemMod  */
  YYSYMBOL_SubsystemName = 72,             /* SubsystemName  */
  YYSYMBOL_SubsystemBase = 73,             /* SubsystemBase  */
  YYSYMBOL_MsgOption = 74,                 /* MsgOption  */
  YYSYMBOL_WaitTime = 75,                  /* WaitTime  */
  YYSYMBOL_Error = 76,                     /* Error  */
  YYSYMBOL_ServerPrefix = 77,              /* ServerPrefix  */
  YYSYMBOL_UserPrefix = 78,                /* UserPrefix  */
  YYSYMBOL_ServerDemux = 79,               /* ServerDemux  */
  YYSYMBOL_Import = 80,                    /* Import  */
  YYSYMBOL_ImportIndicant = 81,            /* ImportIndicant  */
  YYSYMBOL_RCSDecl = 82,                   /* RCSDecl  */
  YYSYMBOL_TypeDecl = 83,                  /* TypeDecl  */
  YYSYMBOL_NamedTypeSpec = 84,             /* NamedTypeSpec  */
  YYSYMBOL_TransTypeSpec = 85,             /* TransTypeSpec  */
  YYSYMBOL_TypeSpec = 86,                  /* TypeSpec  */
  YYSYMBOL_BasicTypeSpec = 87,             /* BasicTypeSpec  */
  YYSYMBOL_IPCFlags = 88,                  /* IPCFlags  */
  YYSYMBOL_PrimIPCType = 89,               /* PrimIPCType  */
  YYSYMBOL_IPCType = 90,                   /* IPCType  */
  YYSYMBOL_PrevTypeSpec = 91,              /* PrevTypeSpec  */
  YYSYMBOL_VarArrayHead = 92,              /* VarArrayHead  */
  YYSYMBOL_ArrayHead = 93,                 /* ArrayHead  */
  YYSYMBOL_StructHead = 94,                /* StructHead  */
  YYSYMBOL_CStringSpec = 95,               /* CStringSpec  */
  YYSYMBOL_IntExp = 96,                    /* IntExp  */
  YYSYMBOL_RoutineDecl = 97,               /* RoutineDecl  */
  YYSYMBOL_Routine = 98,                   /* Routine  */
  YYSYMBOL_SimpleRoutine = 99,             /* SimpleRoutine  */
  YYSYMBOL_Arguments = 100,                /* Arguments  */
  YYSYMBOL_ArgumentList = 101,             /* ArgumentList  */
  YYSYMBOL_Argument = 102,                 /* Argument  */
  YYSYMBOL_Direction = 103,                /* Direction  */
  YYSYMBOL_ArgumentType = 104,             /* ArgumentType  */
  YYSYMBOL_LookString = 105,               /* LookString  */
  YYSYMBOL_LookFileName = 106,             /* LookFileName  */
  YYSYMBOL_LookQString = 107               /* LookQString  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   246

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  65
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  43
/* YYNRULES -- Number of rules.  */
#define YYNRULES  103
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  204

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   319


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   160,   160,   161,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   182,   184,   186,   187,   188,   189,   193,
     206,   218,   219,   222,   231,   242,   245,   248,   265,   271,
     279,   287,   295,   303,   311,   322,   323,   324,   327,   337,
     347,   351,   353,   373,   388,   408,   423,   437,   446,   458,
     460,   462,   464,   466,   468,   470,   474,   480,   490,   491,
     498,   507,   513,   517,   519,   543,   547,   549,   551,   556,
     560,   564,   566,   571,   573,   575,   577,   579,   581,   586,
     587,   590,   594,   598,   600,   605,   607,   614,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   637,
     643,   648,   652,   656
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "sySkip", "syRoutine",
  "sySimpleRoutine", "sySubsystem", "syKernelUser", "syKernelServer",
  "syMsgOption", "syMsgSeqno", "syWaitTime", "syNoWaitTime", "syErrorProc",
  "syServerPrefix", "syUserPrefix", "syServerDemux", "syRCSId", "syImport",
  "syUImport", "sySImport", "syIn", "syOut", "syInOut", "syRequestPort",
  "syReplyPort", "sySReplyPort", "syUReplyPort", "syType", "syArray",
  "syStruct", "syOf", "syInTran", "syOutTran", "syDestructor", "syCType",
  "syCUserType", "syCServerType", "syCString", "syColon", "sySemi",
  "syComma", "syPlus", "syMinus", "syStar", "syDiv", "syLParen",
  "syRParen", "syEqual", "syCaret", "syTilde", "syLAngle", "syRAngle",
  "syLBrack", "syRBrack", "syBar", "syError", "syNumber", "sySymbolicType",
  "syIdentifier", "syString", "syQString", "syFileName", "syIPCFlag",
  "syInTranPayload", "$accept", "Statements", "Statement", "Subsystem",
  "SubsystemStart", "SubsystemMods", "SubsystemMod", "SubsystemName",
  "SubsystemBase", "MsgOption", "WaitTime", "Error", "ServerPrefix",
  "UserPrefix", "ServerDemux", "Import", "ImportIndicant", "RCSDecl",
  "TypeDecl", "NamedTypeSpec", "TransTypeSpec", "TypeSpec",
  "BasicTypeSpec", "IPCFlags", "PrimIPCType", "IPCType", "PrevTypeSpec",
  "VarArrayHead", "ArrayHead", "StructHead", "CStringSpec", "IntExp",
  "RoutineDecl", "Routine", "SimpleRoutine", "Arguments", "ArgumentList",
  "Argument", "Direction", "ArgumentType", "LookString", "LookFileName",
  "LookQString", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319
};
#endif

#define YYPACT_NINF (-114)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-104)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -114,    50,  -114,    -5,   -29,   -21,    -2,  -114,  -114,     1,
      23,    40,    51,    53,  -114,  -114,    18,  -114,    74,    75,
      92,    93,    95,    96,    97,    99,   100,   108,  -114,  -114,
      22,    -1,   133,  -114,  -114,   111,   106,   106,  -114,  -114,
    -114,  -114,    68,  -114,  -114,    -7,  -114,  -114,  -114,  -114,
    -114,  -114,  -114,  -114,  -114,  -114,    94,    98,  -114,  -114,
    -114,    91,   101,  -114,    62,  -114,  -114,   -17,  -114,  -114,
    -114,  -114,   103,  -114,  -114,  -114,  -114,  -114,  -114,  -114,
    -114,  -114,  -114,  -114,  -114,  -114,  -114,  -114,   109,   115,
     104,   112,   113,   114,   -35,   -17,  -114,  -114,  -114,   -28,
    -114,  -114,   116,  -114,  -114,   -17,   -17,   -17,  -114,  -114,
    -114,  -114,    70,   118,   -20,   -32,    54,   120,  -114,   125,
     129,   130,   131,   134,   135,   136,   -35,  -114,  -114,  -114,
    -114,   117,   -24,   -32,   128,  -114,    59,    63,   138,    76,
     -32,   119,   121,   122,   123,   124,   126,   127,  -114,    68,
    -114,  -114,   -32,   141,   102,  -114,   -32,   -32,   -32,   -32,
     148,   153,   -32,  -114,    32,   132,   137,   142,  -114,  -114,
    -114,   139,   146,    80,  -114,  -114,     3,     3,  -114,  -114,
    -114,  -114,    84,   -31,   143,   144,   140,  -114,   145,   161,
    -114,  -114,   147,   150,   154,   149,  -114,   156,   157,  -114,
     151,  -114,  -114,  -114
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,    20,    29,     0,
       0,     0,     0,     0,    17,     3,     0,    21,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    79,    80,
       0,     0,     0,    18,    13,     0,     0,     0,    30,    31,
      32,    33,     0,    39,     4,     0,     6,     5,     7,     8,
       9,    10,    15,    16,    11,    12,     0,     0,    35,    36,
      37,     0,     0,    14,    88,    81,    82,     0,    23,    24,
      25,    22,     0,    27,    28,    34,    38,    97,    98,    96,
      89,    90,    91,    92,    93,    94,    95,    83,     0,    85,
       0,     0,     0,     0,     0,     0,    61,    62,    65,    40,
      41,    49,    63,    56,    50,     0,     0,     0,    55,    26,
      19,    84,    88,     0,     0,     0,     0,     0,    53,     0,
       0,     0,     0,     0,     0,     0,     0,    51,    52,    54,
      86,     0,     0,     0,     0,    77,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    64,    99,
     100,    58,     0,     0,     0,    66,     0,     0,     0,     0,
       0,     0,     0,    71,    58,     0,     0,     0,    46,    47,
      48,     0,    87,     0,    67,    78,    73,    74,    75,    76,
      69,    70,     0,     0,     0,     0,     0,    43,     0,     0,
      72,    57,     0,     0,     0,    59,    68,     0,     0,    45,
       0,    42,    44,    60
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -114,  -114,  -114,  -114,  -114,  -114,  -114,  -114,  -114,  -114,
    -114,  -114,  -114,  -114,  -114,  -114,  -114,  -114,  -114,    64,
    -114,    36,  -114,    29,    71,   152,  -114,  -114,  -114,  -114,
    -114,  -113,  -114,  -114,  -114,   163,    82,  -114,  -114,  -114,
    -114,  -114,  -114
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     1,    15,    16,    17,    45,    71,    72,   110,    18,
      19,    20,    21,    22,    23,    24,    61,    25,    26,    43,
      99,   100,   101,   172,   102,   103,   104,   105,   106,   107,
     108,   136,    27,    28,    29,    65,    88,    89,    90,   151,
      30,    31,    32
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      68,    69,   137,   139,   119,   120,   121,   122,   123,   124,
     188,    34,    91,    92,   133,   152,   191,    58,    59,    60,
     154,    93,    96,    97,   132,   135,   133,   164,    35,    94,
     153,    56,    95,    57,   134,    33,   125,   135,    36,   173,
      96,    97,    98,   176,   177,   178,   179,   158,   159,   182,
       2,     3,    70,     4,     5,     6,     7,    37,    44,  -101,
      38,  -101,     8,     9,    10,    11,    12,  -103,  -102,  -102,
    -102,    77,    78,    79,   156,   157,   158,   159,    13,    77,
      78,    79,    39,    80,    81,    82,    83,    84,    85,    86,
      14,    80,    81,    82,    83,    84,    85,    86,   138,    40,
     133,   156,   157,   158,   159,   156,   157,   158,   159,    87,
      41,   135,    42,   160,    46,    47,    67,   161,   156,   157,
     158,   159,   156,   157,   158,   159,   156,   157,   158,   159,
     163,   118,    48,    49,   189,    50,    51,    52,   190,    53,
      54,   127,   128,   129,   156,   157,   158,   159,    55,   175,
      62,    63,    64,    75,    73,   112,   111,   131,    74,   155,
     109,   140,    76,   113,   141,   114,   115,   116,   142,   143,
     144,   126,   174,   145,   146,   147,   149,   162,   165,   180,
     166,   167,   168,   169,   181,   170,   171,   188,   186,   192,
     193,   184,   196,   183,   130,   150,   185,   148,   187,   194,
      66,   199,   200,   201,   202,   203,   197,     0,   195,   198,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117
};

static const yytype_int16 yycheck[] =
{
       7,     8,   115,   116,    32,    33,    34,    35,    36,    37,
      41,    40,    29,    30,    46,    39,    47,    18,    19,    20,
     133,    38,    57,    58,    44,    57,    46,   140,    57,    46,
      54,     9,    49,    11,    54,    40,    64,    57,    59,   152,
      57,    58,    59,   156,   157,   158,   159,    44,    45,   162,
       0,     1,    59,     3,     4,     5,     6,    59,    40,     9,
      59,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,     9,    10,    11,    42,    43,    44,    45,    28,     9,
      10,    11,    59,    21,    22,    23,    24,    25,    26,    27,
      40,    21,    22,    23,    24,    25,    26,    27,    44,    59,
      46,    42,    43,    44,    45,    42,    43,    44,    45,    47,
      59,    57,    59,    54,    40,    40,    48,    54,    42,    43,
      44,    45,    42,    43,    44,    45,    42,    43,    44,    45,
      54,    95,    40,    40,    54,    40,    40,    40,    54,    40,
      40,   105,   106,   107,    42,    43,    44,    45,    40,    47,
      17,    40,    46,    62,    60,    40,    47,    39,    60,    31,
      57,    41,    61,    59,    39,    53,    53,    53,    39,    39,
      39,    55,    31,    39,    39,    39,    59,    39,    59,    31,
      59,    59,    59,    59,    31,    59,    59,    41,    46,    46,
      46,    59,    31,   164,   112,   131,    59,   126,    59,    59,
      37,    47,    53,    47,    47,    54,    59,    -1,    63,    59,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    66,     0,     1,     3,     4,     5,     6,    12,    13,
      14,    15,    16,    28,    40,    67,    68,    69,    74,    75,
      76,    77,    78,    79,    80,    82,    83,    97,    98,    99,
     105,   106,   107,    40,    40,    57,    59,    59,    59,    59,
      59,    59,    59,    84,    40,    70,    40,    40,    40,    40,
      40,    40,    40,    40,    40,    40,     9,    11,    18,    19,
      20,    81,    17,    40,    46,   100,   100,    48,     7,     8,
      59,    71,    72,    60,    60,    62,    61,     9,    10,    11,
      21,    22,    23,    24,    25,    26,    27,    47,   101,   102,
     103,    29,    30,    38,    46,    49,    57,    58,    59,    85,
      86,    87,    89,    90,    91,    92,    93,    94,    95,    57,
      73,    47,    40,    59,    53,    53,    53,    90,    86,    32,
      33,    34,    35,    36,    37,    64,    55,    86,    86,    86,
     101,    39,    44,    46,    54,    57,    96,    96,    44,    96,
      41,    39,    39,    39,    39,    39,    39,    39,    89,    59,
      84,   104,    39,    54,    96,    31,    42,    43,    44,    45,
      54,    54,    39,    54,    96,    59,    59,    59,    59,    59,
      59,    59,    88,    96,    31,    47,    96,    96,    96,    96,
      31,    31,    96,    88,    59,    59,    46,    59,    41,    54,
      54,    47,    46,    46,    59,    63,    31,    59,    59,    47,
      53,    47,    47,    54
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    65,    66,    66,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    68,
      69,    70,    70,    71,    71,    72,    73,    74,    75,    75,
      76,    77,    78,    79,    80,    81,    81,    81,    82,    83,
      84,    85,    85,    85,    85,    85,    85,    85,    85,    86,
      86,    86,    86,    86,    86,    86,    87,    87,    88,    88,
      88,    89,    89,    90,    90,    91,    92,    92,    92,    93,
      94,    95,    95,    96,    96,    96,    96,    96,    96,    97,
      97,    98,    99,   100,   100,   101,   101,   102,   103,   103,
     103,   103,   103,   103,   103,   103,   103,   103,   103,   104,
     104,   105,   106,   107
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     3,     2,     2,     1,     2,     4,
       1,     0,     2,     1,     1,     1,     1,     3,     3,     1,
       2,     2,     2,     2,     3,     1,     1,     1,     3,     2,
       3,     1,     8,     5,     8,     7,     4,     4,     4,     1,
       1,     2,     2,     2,     2,     1,     1,     6,     0,     3,
       5,     1,     1,     1,     3,     1,     4,     5,     7,     5,
       5,     4,     6,     3,     3,     3,     3,     1,     3,     1,
       1,     3,     3,     2,     3,     1,     3,     5,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     0,     0
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 12: /* Statement: RoutineDecl sySemi  */
#line 173 "parser.y"
{
    statement_t *st = stAlloc();

    st->stKind = skRoutine;
    st->stRoutine = (yyvsp[-1].routine);
    rtCheckRoutine((yyvsp[-1].routine));
    if (BeVerbose)
	rtPrintRoutine((yyvsp[-1].routine));
}
#line 1557 "parser.c"
    break;

  case 13: /* Statement: sySkip sySemi  */
#line 183 "parser.y"
                                { rtSkip(1); }
#line 1563 "parser.c"
    break;

  case 14: /* Statement: sySkip syNumber sySemi  */
#line 185 "parser.y"
                                { rtSkip((yyvsp[-1].number)); }
#line 1569 "parser.c"
    break;

  case 18: /* Statement: error sySemi  */
#line 190 "parser.y"
                                { yyerrok; }
#line 1575 "parser.c"
    break;

  case 19: /* Subsystem: SubsystemStart SubsystemMods SubsystemName SubsystemBase  */
#line 195 "parser.y"
{
    if (BeVerbose)
    {
	printf("Subsystem %s: base = %u%s%s\n\n",
	       SubsystemName, SubsystemBase,
	       IsKernelUser ? ", KernelUser" : "",
	       IsKernelServer ? ", KernelServer" : "");
    }
}
#line 1589 "parser.c"
    break;

  case 20: /* SubsystemStart: sySubsystem  */
#line 207 "parser.y"
{
    if (SubsystemName != strNULL)
    {
	warn("previous Subsystem decl (of %s) will be ignored", SubsystemName);
	IsKernelUser = FALSE;
	IsKernelServer = FALSE;
	strfree((string_t) SubsystemName);
    }
}
#line 1603 "parser.c"
    break;

  case 23: /* SubsystemMod: syKernelUser  */
#line 223 "parser.y"
{
    if (IsKernelUser)
	warn("duplicate KernelUser keyword");
    IsKernelUser = TRUE;
    port_size = vm_offset_size;
    port_size_in_bits = vm_offset_size_in_bits;
    init_type();
}
#line 1616 "parser.c"
    break;

  case 24: /* SubsystemMod: syKernelServer  */
#line 232 "parser.y"
{
    if (IsKernelServer)
	warn("duplicate KernelServer keyword");
    IsKernelServer = TRUE;
    port_size = vm_offset_size;
    port_size_in_bits = vm_offset_size_in_bits;
    init_type();
}
#line 1629 "parser.c"
    break;

  case 25: /* SubsystemName: syIdentifier  */
#line 242 "parser.y"
                                                { SubsystemName = (yyvsp[0].identifier); }
#line 1635 "parser.c"
    break;

  case 26: /* SubsystemBase: syNumber  */
#line 245 "parser.y"
                                                { SubsystemBase = (yyvsp[0].number); }
#line 1641 "parser.c"
    break;

  case 27: /* MsgOption: LookString syMsgOption syString  */
#line 249 "parser.y"
{
    if (streql((yyvsp[0].string), "MACH_MSG_OPTION_NONE"))
    {
	MsgOption = strNULL;
	if (BeVerbose)
	    printf("MsgOption: canceled\n\n");
    }
    else
    {
	MsgOption = (yyvsp[0].string);
	if (BeVerbose)
	    printf("MsgOption %s\n\n",(yyvsp[0].string));
    }
}
#line 1660 "parser.c"
    break;

  case 28: /* WaitTime: LookString syWaitTime syString  */
#line 266 "parser.y"
{
    WaitTime = (yyvsp[0].string);
    if (BeVerbose)
	printf("WaitTime %s\n\n", WaitTime);
}
#line 1670 "parser.c"
    break;

  case 29: /* WaitTime: syNoWaitTime  */
#line 272 "parser.y"
{
    WaitTime = strNULL;
    if (BeVerbose)
	printf("NoWaitTime\n\n");
}
#line 1680 "parser.c"
    break;

  case 30: /* Error: syErrorProc syIdentifier  */
#line 280 "parser.y"
{
    ErrorProc = (yyvsp[0].identifier);
    if (BeVerbose)
	printf("ErrorProc %s\n\n", ErrorProc);
}
#line 1690 "parser.c"
    break;

  case 31: /* ServerPrefix: syServerPrefix syIdentifier  */
#line 288 "parser.y"
{
    ServerPrefix = (yyvsp[0].identifier);
    if (BeVerbose)
	printf("ServerPrefix %s\n\n", ServerPrefix);
}
#line 1700 "parser.c"
    break;

  case 32: /* UserPrefix: syUserPrefix syIdentifier  */
#line 296 "parser.y"
{
    UserPrefix = (yyvsp[0].identifier);
    if (BeVerbose)
	printf("UserPrefix %s\n\n", UserPrefix);
}
#line 1710 "parser.c"
    break;

  case 33: /* ServerDemux: syServerDemux syIdentifier  */
#line 304 "parser.y"
{
    ServerDemux = (yyvsp[0].identifier);
    if (BeVerbose)
	printf("ServerDemux %s\n\n", ServerDemux);
}
#line 1720 "parser.c"
    break;

  case 34: /* Import: LookFileName ImportIndicant syFileName  */
#line 312 "parser.y"
{
    statement_t *st = stAlloc();
    st->stKind = (yyvsp[-1].statement_kind);
    st->stFileName = (yyvsp[0].string);

    if (BeVerbose)
	printf("%s %s\n\n", import_name((yyvsp[-1].statement_kind)), (yyvsp[0].string));
}
#line 1733 "parser.c"
    break;

  case 35: /* ImportIndicant: syImport  */
#line 322 "parser.y"
                                                { (yyval.statement_kind) = skImport; }
#line 1739 "parser.c"
    break;

  case 36: /* ImportIndicant: syUImport  */
#line 323 "parser.y"
                                                { (yyval.statement_kind) = skUImport; }
#line 1745 "parser.c"
    break;

  case 37: /* ImportIndicant: sySImport  */
#line 324 "parser.y"
                                                { (yyval.statement_kind) = skSImport; }
#line 1751 "parser.c"
    break;

  case 38: /* RCSDecl: LookQString syRCSId syQString  */
#line 328 "parser.y"
{
    if (RCSId != strNULL)
	warn("previous RCS decl will be ignored");
    if (BeVerbose)
	printf("RCSId %s\n\n", (yyvsp[0].string));
    RCSId = (yyvsp[0].string);
}
#line 1763 "parser.c"
    break;

  case 39: /* TypeDecl: syType NamedTypeSpec  */
#line 338 "parser.y"
{
    identifier_t name = (yyvsp[0].type)->itName;

    if (itLookUp(name) != itNULL)
	warn("overriding previous definition of %s", name);
    itInsert(name, (yyvsp[0].type));
}
#line 1775 "parser.c"
    break;

  case 40: /* NamedTypeSpec: syIdentifier syEqual TransTypeSpec  */
#line 348 "parser.y"
                                { itTypeDecl((yyvsp[-2].identifier), (yyval.type) = (yyvsp[0].type)); }
#line 1781 "parser.c"
    break;

  case 41: /* TransTypeSpec: TypeSpec  */
#line 352 "parser.y"
                                { (yyval.type) = itResetType((yyvsp[0].type)); }
#line 1787 "parser.c"
    break;

  case 42: /* TransTypeSpec: TransTypeSpec syInTran syColon syIdentifier syIdentifier syLParen syIdentifier syRParen  */
#line 355 "parser.y"
{
    (yyval.type) = (yyvsp[-7].type);

    if (((yyval.type)->itTransType != strNULL) && !streql((yyval.type)->itTransType, (yyvsp[-4].identifier)))
	warn("conflicting translation types (%s, %s)",
	     (yyval.type)->itTransType, (yyvsp[-4].identifier));
    (yyval.type)->itTransType = (yyvsp[-4].identifier);

    if (((yyval.type)->itInTrans != strNULL) && !streql((yyval.type)->itInTrans, (yyvsp[-3].identifier)))
	warn("conflicting in-translation functions (%s, %s)",
	     (yyval.type)->itInTrans, (yyvsp[-3].identifier));
    (yyval.type)->itInTrans = (yyvsp[-3].identifier);

    if (((yyval.type)->itServerType != strNULL) && !streql((yyval.type)->itServerType, (yyvsp[-1].identifier)))
	warn("conflicting server types (%s, %s)",
	     (yyval.type)->itServerType, (yyvsp[-1].identifier));
    (yyval.type)->itServerType = (yyvsp[-1].identifier);
}
#line 1810 "parser.c"
    break;

  case 43: /* TransTypeSpec: TransTypeSpec syInTranPayload syColon syIdentifier syIdentifier  */
#line 375 "parser.y"
{
    (yyval.type) = (yyvsp[-4].type);

    if (((yyval.type)->itTransType != strNULL) && !streql((yyval.type)->itTransType, (yyvsp[-1].identifier)))
	warn("conflicting translation types (%s, %s)",
	     (yyval.type)->itTransType, (yyvsp[-1].identifier));
    (yyval.type)->itTransType = (yyvsp[-1].identifier);

    if (((yyval.type)->itInTransPayload != strNULL) && !streql((yyval.type)->itInTransPayload, (yyvsp[0].identifier)))
	warn("conflicting in-translation functions (%s, %s)",
	     (yyval.type)->itInTransPayload, (yyvsp[0].identifier));
    (yyval.type)->itInTransPayload = (yyvsp[0].identifier);
}
#line 1828 "parser.c"
    break;

  case 44: /* TransTypeSpec: TransTypeSpec syOutTran syColon syIdentifier syIdentifier syLParen syIdentifier syRParen  */
#line 390 "parser.y"
{
    (yyval.type) = (yyvsp[-7].type);

    if (((yyval.type)->itServerType != strNULL) && !streql((yyval.type)->itServerType, (yyvsp[-4].identifier)))
	warn("conflicting server types (%s, %s)",
	     (yyval.type)->itServerType, (yyvsp[-4].identifier));
    (yyval.type)->itServerType = (yyvsp[-4].identifier);

    if (((yyval.type)->itOutTrans != strNULL) && !streql((yyval.type)->itOutTrans, (yyvsp[-3].identifier)))
	warn("conflicting out-translation functions (%s, %s)",
	     (yyval.type)->itOutTrans, (yyvsp[-3].identifier));
    (yyval.type)->itOutTrans = (yyvsp[-3].identifier);

    if (((yyval.type)->itTransType != strNULL) && !streql((yyval.type)->itTransType, (yyvsp[-1].identifier)))
	warn("conflicting translation types (%s, %s)",
	     (yyval.type)->itTransType, (yyvsp[-1].identifier));
    (yyval.type)->itTransType = (yyvsp[-1].identifier);
}
#line 1851 "parser.c"
    break;

  case 45: /* TransTypeSpec: TransTypeSpec syDestructor syColon syIdentifier syLParen syIdentifier syRParen  */
#line 410 "parser.y"
{
    (yyval.type) = (yyvsp[-6].type);

    if (((yyval.type)->itDestructor != strNULL) && !streql((yyval.type)->itDestructor, (yyvsp[-3].identifier)))
	warn("conflicting destructor functions (%s, %s)",
	     (yyval.type)->itDestructor, (yyvsp[-3].identifier));
    (yyval.type)->itDestructor = (yyvsp[-3].identifier);

    if (((yyval.type)->itTransType != strNULL) && !streql((yyval.type)->itTransType, (yyvsp[-1].identifier)))
	warn("conflicting translation types (%s, %s)",
	     (yyval.type)->itTransType, (yyvsp[-1].identifier));
    (yyval.type)->itTransType = (yyvsp[-1].identifier);
}
#line 1869 "parser.c"
    break;

  case 46: /* TransTypeSpec: TransTypeSpec syCType syColon syIdentifier  */
#line 424 "parser.y"
{
    (yyval.type) = (yyvsp[-3].type);

    if (((yyval.type)->itUserType != strNULL) && !streql((yyval.type)->itUserType, (yyvsp[0].identifier)))
	warn("conflicting user types (%s, %s)",
	     (yyval.type)->itUserType, (yyvsp[0].identifier));
    (yyval.type)->itUserType = (yyvsp[0].identifier);

    if (((yyval.type)->itServerType != strNULL) && !streql((yyval.type)->itServerType, (yyvsp[0].identifier)))
	warn("conflicting server types (%s, %s)",
	     (yyval.type)->itServerType, (yyvsp[0].identifier));
    (yyval.type)->itServerType = (yyvsp[0].identifier);
}
#line 1887 "parser.c"
    break;

  case 47: /* TransTypeSpec: TransTypeSpec syCUserType syColon syIdentifier  */
#line 438 "parser.y"
{
    (yyval.type) = (yyvsp[-3].type);

    if (((yyval.type)->itUserType != strNULL) && !streql((yyval.type)->itUserType, (yyvsp[0].identifier)))
	warn("conflicting user types (%s, %s)",
	     (yyval.type)->itUserType, (yyvsp[0].identifier));
    (yyval.type)->itUserType = (yyvsp[0].identifier);
}
#line 1900 "parser.c"
    break;

  case 48: /* TransTypeSpec: TransTypeSpec syCServerType syColon syIdentifier  */
#line 448 "parser.y"
{
    (yyval.type) = (yyvsp[-3].type);

    if (((yyval.type)->itServerType != strNULL) && !streql((yyval.type)->itServerType, (yyvsp[0].identifier)))
	warn("conflicting server types (%s, %s)",
	     (yyval.type)->itServerType, (yyvsp[0].identifier));
    (yyval.type)->itServerType = (yyvsp[0].identifier);
}
#line 1913 "parser.c"
    break;

  case 49: /* TypeSpec: BasicTypeSpec  */
#line 459 "parser.y"
                                { (yyval.type) = (yyvsp[0].type); }
#line 1919 "parser.c"
    break;

  case 50: /* TypeSpec: PrevTypeSpec  */
#line 461 "parser.y"
                                { (yyval.type) = (yyvsp[0].type); }
#line 1925 "parser.c"
    break;

  case 51: /* TypeSpec: VarArrayHead TypeSpec  */
#line 463 "parser.y"
                                { (yyval.type) = itVarArrayDecl((yyvsp[-1].number), (yyvsp[0].type)); }
#line 1931 "parser.c"
    break;

  case 52: /* TypeSpec: ArrayHead TypeSpec  */
#line 465 "parser.y"
                                { (yyval.type) = itArrayDecl((yyvsp[-1].number), (yyvsp[0].type)); }
#line 1937 "parser.c"
    break;

  case 53: /* TypeSpec: syCaret TypeSpec  */
#line 467 "parser.y"
                                { (yyval.type) = itPtrDecl((yyvsp[0].type)); }
#line 1943 "parser.c"
    break;

  case 54: /* TypeSpec: StructHead TypeSpec  */
#line 469 "parser.y"
                                { (yyval.type) = itStructDecl((yyvsp[-1].number), (yyvsp[0].type)); }
#line 1949 "parser.c"
    break;

  case 55: /* TypeSpec: CStringSpec  */
#line 471 "parser.y"
                                { (yyval.type) = (yyvsp[0].type); }
#line 1955 "parser.c"
    break;

  case 56: /* BasicTypeSpec: IPCType  */
#line 475 "parser.y"
{
    (yyval.type) = itShortDecl((yyvsp[0].symtype).innumber, (yyvsp[0].symtype).instr,
		     (yyvsp[0].symtype).outnumber, (yyvsp[0].symtype).outstr,
		     (yyvsp[0].symtype).size);
}
#line 1965 "parser.c"
    break;

  case 57: /* BasicTypeSpec: syLParen IPCType syComma IntExp IPCFlags syRParen  */
#line 482 "parser.y"
{
    (yyval.type) = itLongDecl((yyvsp[-4].symtype).innumber, (yyvsp[-4].symtype).instr,
		    (yyvsp[-4].symtype).outnumber, (yyvsp[-4].symtype).outstr,
		    (yyvsp[-4].symtype).size, (yyvsp[-2].number), (yyvsp[-1].flag));
}
#line 1975 "parser.c"
    break;

  case 58: /* IPCFlags: %empty  */
#line 490 "parser.y"
                                { (yyval.flag) = flNone; }
#line 1981 "parser.c"
    break;

  case 59: /* IPCFlags: IPCFlags syComma syIPCFlag  */
#line 492 "parser.y"
{
    if ((yyvsp[-2].flag) & (yyvsp[0].flag))
	warn("redundant IPC flag ignored");
    else
	(yyval.flag) = (yyvsp[-2].flag) | (yyvsp[0].flag);
}
#line 1992 "parser.c"
    break;

  case 60: /* IPCFlags: IPCFlags syComma syIPCFlag syLBrack syRBrack  */
#line 499 "parser.y"
{
    if ((yyvsp[-2].flag) != flDealloc)
	warn("only Dealloc is variable");
    else
	(yyval.flag) = (yyvsp[-4].flag) | flMaybeDealloc;
}
#line 2003 "parser.c"
    break;

  case 61: /* PrimIPCType: syNumber  */
#line 508 "parser.y"
{
    (yyval.symtype).innumber = (yyval.symtype).outnumber = (yyvsp[0].number);
    (yyval.symtype).instr = (yyval.symtype).outstr = strNULL;
    (yyval.symtype).size = 0;
}
#line 2013 "parser.c"
    break;

  case 62: /* PrimIPCType: sySymbolicType  */
#line 514 "parser.y"
                                { (yyval.symtype) = (yyvsp[0].symtype); }
#line 2019 "parser.c"
    break;

  case 63: /* IPCType: PrimIPCType  */
#line 518 "parser.y"
                                { (yyval.symtype) = (yyvsp[0].symtype); }
#line 2025 "parser.c"
    break;

  case 64: /* IPCType: PrimIPCType syBar PrimIPCType  */
#line 520 "parser.y"
{
    if ((yyvsp[-2].symtype).size != (yyvsp[0].symtype).size)
    {
	if ((yyvsp[-2].symtype).size == 0)
	    (yyval.symtype).size = (yyvsp[0].symtype).size;
	else if ((yyvsp[0].symtype).size == 0)
	    (yyval.symtype).size = (yyvsp[-2].symtype).size;
	else
	{
	    error("sizes in IPCTypes (%s %s %d, %s %s %d) aren't equal",
		  (yyvsp[-2].symtype).instr, (yyvsp[-2].symtype).outstr, (yyvsp[-2].symtype).size, (yyvsp[0].symtype).instr, (yyvsp[0].symtype).outstr, (yyvsp[0].symtype).size);
	    (yyval.symtype).size = 0;
	}
    }
    else
	(yyval.symtype).size = (yyvsp[-2].symtype).size;
    (yyval.symtype).innumber = (yyvsp[-2].symtype).innumber;
    (yyval.symtype).instr = (yyvsp[-2].symtype).instr;
    (yyval.symtype).outnumber = (yyvsp[0].symtype).outnumber;
    (yyval.symtype).outstr = (yyvsp[0].symtype).outstr;
}
#line 2051 "parser.c"
    break;

  case 65: /* PrevTypeSpec: syIdentifier  */
#line 544 "parser.y"
                                { (yyval.type) = itPrevDecl((yyvsp[0].identifier)); }
#line 2057 "parser.c"
    break;

  case 66: /* VarArrayHead: syArray syLBrack syRBrack syOf  */
#line 548 "parser.y"
                                { (yyval.number) = 0; }
#line 2063 "parser.c"
    break;

  case 67: /* VarArrayHead: syArray syLBrack syStar syRBrack syOf  */
#line 550 "parser.y"
                                { (yyval.number) = 0; }
#line 2069 "parser.c"
    break;

  case 68: /* VarArrayHead: syArray syLBrack syStar syColon IntExp syRBrack syOf  */
#line 553 "parser.y"
                                { (yyval.number) = (yyvsp[-2].number); }
#line 2075 "parser.c"
    break;

  case 69: /* ArrayHead: syArray syLBrack IntExp syRBrack syOf  */
#line 557 "parser.y"
                                { (yyval.number) = (yyvsp[-2].number); }
#line 2081 "parser.c"
    break;

  case 70: /* StructHead: syStruct syLBrack IntExp syRBrack syOf  */
#line 561 "parser.y"
                                { (yyval.number) = (yyvsp[-2].number); }
#line 2087 "parser.c"
    break;

  case 71: /* CStringSpec: syCString syLBrack IntExp syRBrack  */
#line 565 "parser.y"
                                { (yyval.type) = itCStringDecl((yyvsp[-1].number), FALSE); }
#line 2093 "parser.c"
    break;

  case 72: /* CStringSpec: syCString syLBrack syStar syColon IntExp syRBrack  */
#line 568 "parser.y"
                                { (yyval.type) = itCStringDecl((yyvsp[-1].number), TRUE); }
#line 2099 "parser.c"
    break;

  case 73: /* IntExp: IntExp syPlus IntExp  */
#line 572 "parser.y"
                                { (yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number);	}
#line 2105 "parser.c"
    break;

  case 74: /* IntExp: IntExp syMinus IntExp  */
#line 574 "parser.y"
                                { (yyval.number) = (yyvsp[-2].number) - (yyvsp[0].number);	}
#line 2111 "parser.c"
    break;

  case 75: /* IntExp: IntExp syStar IntExp  */
#line 576 "parser.y"
                                { (yyval.number) = (yyvsp[-2].number) * (yyvsp[0].number);	}
#line 2117 "parser.c"
    break;

  case 76: /* IntExp: IntExp syDiv IntExp  */
#line 578 "parser.y"
                                { (yyval.number) = (yyvsp[-2].number) / (yyvsp[0].number);	}
#line 2123 "parser.c"
    break;

  case 77: /* IntExp: syNumber  */
#line 580 "parser.y"
                                { (yyval.number) = (yyvsp[0].number);	}
#line 2129 "parser.c"
    break;

  case 78: /* IntExp: syLParen IntExp syRParen  */
#line 582 "parser.y"
                                { (yyval.number) = (yyvsp[-1].number);	}
#line 2135 "parser.c"
    break;

  case 79: /* RoutineDecl: Routine  */
#line 586 "parser.y"
                                                        { (yyval.routine) = (yyvsp[0].routine); }
#line 2141 "parser.c"
    break;

  case 80: /* RoutineDecl: SimpleRoutine  */
#line 587 "parser.y"
                                                        { (yyval.routine) = (yyvsp[0].routine); }
#line 2147 "parser.c"
    break;

  case 81: /* Routine: syRoutine syIdentifier Arguments  */
#line 591 "parser.y"
                                { (yyval.routine) = rtMakeRoutine((yyvsp[-1].identifier), (yyvsp[0].argument)); }
#line 2153 "parser.c"
    break;

  case 82: /* SimpleRoutine: sySimpleRoutine syIdentifier Arguments  */
#line 595 "parser.y"
                                { (yyval.routine) = rtMakeSimpleRoutine((yyvsp[-1].identifier), (yyvsp[0].argument)); }
#line 2159 "parser.c"
    break;

  case 83: /* Arguments: syLParen syRParen  */
#line 599 "parser.y"
                                { (yyval.argument) = argNULL; }
#line 2165 "parser.c"
    break;

  case 84: /* Arguments: syLParen ArgumentList syRParen  */
#line 601 "parser.y"
                                { (yyval.argument) = (yyvsp[-1].argument); }
#line 2171 "parser.c"
    break;

  case 85: /* ArgumentList: Argument  */
#line 606 "parser.y"
                                { (yyval.argument) = (yyvsp[0].argument); }
#line 2177 "parser.c"
    break;

  case 86: /* ArgumentList: Argument sySemi ArgumentList  */
#line 608 "parser.y"
{
    (yyval.argument) = (yyvsp[-2].argument);
    (yyval.argument)->argNext = (yyvsp[0].argument);
}
#line 2186 "parser.c"
    break;

  case 87: /* Argument: Direction syIdentifier syColon ArgumentType IPCFlags  */
#line 615 "parser.y"
{
    (yyval.argument) = argAlloc();
    (yyval.argument)->argKind = (yyvsp[-4].direction);
    (yyval.argument)->argName = (yyvsp[-3].identifier);
    (yyval.argument)->argType = (yyvsp[-1].type);
    (yyval.argument)->argFlags = (yyvsp[0].flag);
}
#line 2198 "parser.c"
    break;

  case 88: /* Direction: %empty  */
#line 624 "parser.y"
                                                { (yyval.direction) = akNone; }
#line 2204 "parser.c"
    break;

  case 89: /* Direction: syIn  */
#line 625 "parser.y"
                                                { (yyval.direction) = akIn; }
#line 2210 "parser.c"
    break;

  case 90: /* Direction: syOut  */
#line 626 "parser.y"
                                                { (yyval.direction) = akOut; }
#line 2216 "parser.c"
    break;

  case 91: /* Direction: syInOut  */
#line 627 "parser.y"
                                                { (yyval.direction) = akInOut; }
#line 2222 "parser.c"
    break;

  case 92: /* Direction: syRequestPort  */
#line 628 "parser.y"
                                                { (yyval.direction) = akRequestPort; }
#line 2228 "parser.c"
    break;

  case 93: /* Direction: syReplyPort  */
#line 629 "parser.y"
                                                { (yyval.direction) = akReplyPort; }
#line 2234 "parser.c"
    break;

  case 94: /* Direction: sySReplyPort  */
#line 630 "parser.y"
                                                { (yyval.direction) = akSReplyPort; }
#line 2240 "parser.c"
    break;

  case 95: /* Direction: syUReplyPort  */
#line 631 "parser.y"
                                                { (yyval.direction) = akUReplyPort; }
#line 2246 "parser.c"
    break;

  case 96: /* Direction: syWaitTime  */
#line 632 "parser.y"
                                                { (yyval.direction) = akWaitTime; }
#line 2252 "parser.c"
    break;

  case 97: /* Direction: syMsgOption  */
#line 633 "parser.y"
                                                { (yyval.direction) = akMsgOption; }
#line 2258 "parser.c"
    break;

  case 98: /* Direction: syMsgSeqno  */
#line 634 "parser.y"
                                                { (yyval.direction) = akMsgSeqno; }
#line 2264 "parser.c"
    break;

  case 99: /* ArgumentType: syIdentifier  */
#line 638 "parser.y"
{
    (yyval.type) = itLookUp((yyvsp[0].identifier));
    if ((yyval.type) == itNULL)
	error("type '%s' not defined", (yyvsp[0].identifier));
}
#line 2274 "parser.c"
    break;

  case 100: /* ArgumentType: NamedTypeSpec  */
#line 644 "parser.y"
                                { (yyval.type) = (yyvsp[0].type); }
#line 2280 "parser.c"
    break;

  case 101: /* LookString: %empty  */
#line 648 "parser.y"
                                { LookString(); }
#line 2286 "parser.c"
    break;

  case 102: /* LookFileName: %empty  */
#line 652 "parser.y"
                                { LookFileName(); }
#line 2292 "parser.c"
    break;

  case 103: /* LookQString: %empty  */
#line 656 "parser.y"
                                { LookQString(); }
#line 2298 "parser.c"
    break;


#line 2302 "parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 659 "parser.y"


static const char *
import_name(statement_kind_t sk)
{
    switch (sk)
    {
      case skImport:
	return "Import";
      case skSImport:
	return "SImport";
      case skUImport:
	return "UImport";
      default:
	fatal("import_name(%d): not import statement", (int) sk);
	/*NOTREACHED*/
    }
}
